package org.apache.bcel.verifier.statics;

package .tmp;

import org.apache.bcel.classfile.AnnotationDefault;
import org.apache.bcel.classfile.AnnotationEntry;
import org.apache.bcel.classfile.Annotations;
import org.apache.bcel.classfile.BootstrapMethods;
import org.apache.bcel.classfile.Code;
import org.apache.bcel.classfile.CodeException;
import org.apache.bcel.classfile.ConstantClass;
import org.apache.bcel.classfile.ConstantDouble;
import org.apache.bcel.classfile.ConstantDynamic;
import org.apache.bcel.classfile.ConstantFieldref;
import org.apache.bcel.classfile.ConstantFloat;
import org.apache.bcel.classfile.ConstantInteger;
import org.apache.bcel.classfile.ConstantInterfaceMethodref;
import org.apache.bcel.classfile.ConstantInvokeDynamic;
import org.apache.bcel.classfile.ConstantLong;
import org.apache.bcel.classfile.ConstantMethodHandle;
import org.apache.bcel.classfile.ConstantMethodType;
import org.apache.bcel.classfile.ConstantMethodref;
import org.apache.bcel.classfile.ConstantModule;
import org.apache.bcel.classfile.ConstantNameAndType;
import org.apache.bcel.classfile.ConstantPackage;
import org.apache.bcel.classfile.ConstantPool;
import org.apache.bcel.classfile.ConstantString;
import org.apache.bcel.classfile.ConstantUtf8;
import org.apache.bcel.classfile.ConstantValue;
import org.apache.bcel.classfile.Deprecated;
import org.apache.bcel.classfile.EmptyVisitor;
import org.apache.bcel.classfile.EnclosingMethod;
import org.apache.bcel.classfile.ExceptionTable;
import org.apache.bcel.classfile.Field;
import org.apache.bcel.classfile.InnerClass;
import org.apache.bcel.classfile.InnerClasses;
import org.apache.bcel.classfile.JavaClass;
import org.apache.bcel.classfile.LineNumber;
import org.apache.bcel.classfile.LineNumberTable;
import org.apache.bcel.classfile.LocalVariable;
import org.apache.bcel.classfile.LocalVariableTable;
import org.apache.bcel.classfile.LocalVariableTypeTable;
import org.apache.bcel.classfile.Method;
import org.apache.bcel.classfile.MethodParameters;
import org.apache.bcel.classfile.NestMembers;
import org.apache.bcel.classfile.Node;
import org.apache.bcel.classfile.ParameterAnnotationEntry;
import org.apache.bcel.classfile.ParameterAnnotations;
import org.apache.bcel.classfile.Signature;
import org.apache.bcel.classfile.SourceFile;
import org.apache.bcel.classfile.StackMap;
import org.apache.bcel.classfile.StackMapEntry;
import org.apache.bcel.classfile.Synthetic;
import org.apache.bcel.classfile.Unknown;
import org.apache.bcel.verifier.exc.AssertionViolatedException;

public class StringRepresentation extends EmptyVisitor {
  private String tostring;
  
  private final Node n;
  
  public StringRepresentation(Node n) {
    this.n = n;
    n.accept(this);
  }
  
  public String toString() {
    if (this.tostring == null)
      throw new AssertionViolatedException("Please adapt '" + getClass() + "' to deal with objects of class '" + this.n.getClass() + "'."); 
    return this.tostring;
  }
  
  private String toString(Node obj) {
    String ret;
    try {
      ret = obj.toString();
    } catch (RuntimeException e) {
      String s = obj.getClass().getName();
      s = s.substring(s.lastIndexOf(".") + 1);
      ret = "<<" + s + ">>";
    } 
    return ret;
  }
  
  public void visitAnnotation(Annotations obj) {
    this.tostring = toString(obj);
  }
  
  public void visitAnnotationDefault(AnnotationDefault obj) {
    this.tostring = toString(obj);
  }
  
  public void visitAnnotationEntry(AnnotationEntry obj) {
    this.tostring = toString(obj);
  }
  
  public void visitBootstrapMethods(BootstrapMethods obj) {
    this.tostring = toString(obj);
  }
  
  public void visitCode(Code obj) {
    this.tostring = "<CODE>";
  }
  
  public void visitCodeException(CodeException obj) {
    this.tostring = toString(obj);
  }
  
  public void visitConstantClass(ConstantClass obj) {
    this.tostring = toString(obj);
  }
  
  public void visitConstantDouble(ConstantDouble obj) {
    this.tostring = toString(obj);
  }
  
  public void visitConstantDynamic(ConstantDynamic obj) {
    this.tostring = toString(obj);
  }
  
  public void visitConstantFieldref(ConstantFieldref obj) {
    this.tostring = toString(obj);
  }
  
  public void visitConstantFloat(ConstantFloat obj) {
    this.tostring = toString(obj);
  }
  
  public void visitConstantInteger(ConstantInteger obj) {
    this.tostring = toString(obj);
  }
  
  public void visitConstantInterfaceMethodref(ConstantInterfaceMethodref obj) {
    this.tostring = toString(obj);
  }
  
  public void visitConstantInvokeDynamic(ConstantInvokeDynamic obj) {
    this.tostring = toString(obj);
  }
  
  public void visitConstantLong(ConstantLong obj) {
    this.tostring = toString(obj);
  }
  
  public void visitConstantMethodHandle(ConstantMethodHandle obj) {
    this.tostring = toString(obj);
  }
  
  public void visitConstantMethodref(ConstantMethodref obj) {
    this.tostring = toString(obj);
  }
  
  public void visitConstantMethodType(ConstantMethodType obj) {
    this.tostring = toString(obj);
  }
  
  public void visitConstantModule(ConstantModule obj) {
    this.tostring = toString(obj);
  }
  
  public void visitConstantNameAndType(ConstantNameAndType obj) {
    this.tostring = toString(obj);
  }
  
  public void visitConstantPackage(ConstantPackage obj) {
    this.tostring = toString(obj);
  }
  
  public void visitConstantPool(ConstantPool obj) {
    this.tostring = toString(obj);
  }
  
  public void visitConstantString(ConstantString obj) {
    this.tostring = toString(obj);
  }
  
  public void visitConstantUtf8(ConstantUtf8 obj) {
    this.tostring = toString(obj);
  }
  
  public void visitConstantValue(ConstantValue obj) {
    this.tostring = toString(obj);
  }
  
  public void visitDeprecated(Deprecated obj) {
    this.tostring = toString(obj);
  }
  
  public void visitEnclosingMethod(EnclosingMethod obj) {
    this.tostring = toString(obj);
  }
  
  public void visitExceptionTable(ExceptionTable obj) {
    this.tostring = toString(obj);
  }
  
  public void visitField(Field obj) {
    this.tostring = toString(obj);
  }
  
  public void visitInnerClass(InnerClass obj) {
    this.tostring = toString(obj);
  }
  
  public void visitInnerClasses(InnerClasses obj) {
    this.tostring = toString(obj);
  }
  
  public void visitJavaClass(JavaClass obj) {
    this.tostring = toString(obj);
  }
  
  public void visitLineNumber(LineNumber obj) {
    this.tostring = toString(obj);
  }
  
  public void visitLineNumberTable(LineNumberTable obj) {
    this.tostring = "<LineNumberTable: " + toString(obj) + ">";
  }
  
  public void visitLocalVariable(LocalVariable obj) {
    this.tostring = toString(obj);
  }
  
  public void visitLocalVariableTable(LocalVariableTable obj) {
    this.tostring = "<LocalVariableTable: " + toString(obj) + ">";
  }
  
  public void visitLocalVariableTypeTable(LocalVariableTypeTable obj) {
    this.tostring = toString(obj);
  }
  
  public void visitMethod(Method obj) {
    this.tostring = toString(obj);
  }
  
  public void visitMethodParameters(MethodParameters obj) {
    this.tostring = toString(obj);
  }
  
  public void visitNestMembers(NestMembers obj) {
    this.tostring = toString(obj);
  }
  
  public void visitParameterAnnotation(ParameterAnnotations obj) {
    this.tostring = toString(obj);
  }
  
  public void visitParameterAnnotationEntry(ParameterAnnotationEntry obj) {
    this.tostring = toString(obj);
  }
  
  public void visitSignature(Signature obj) {
    this.tostring = toString(obj);
  }
  
  public void visitSourceFile(SourceFile obj) {
    this.tostring = toString(obj);
  }
  
  public void visitStackMap(StackMap obj) {
    this.tostring = toString(obj);
  }
  
  public void visitStackMapEntry(StackMapEntry obj) {
    this.tostring = toString(obj);
  }
  
  public void visitSynthetic(Synthetic obj) {
    this.tostring = toString(obj);
  }
  
  public void visitUnknown(Unknown obj) {
    this.tostring = toString(obj);
  }
}
